//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GfBbgRg[(TEdit, TMemo)̔wi摜ɂ
//  ҏẄȊOWM_ERASEBKGNDbZ[Wōĕ`悷
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2014N1222 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TMyMemo = class (TMemo)
  private
    FBitmap : TBitmap;
    FBrush  : HBRUSH;
    procedure WMEraseBkgnd(var Message: TWmEraseBkgnd); message WM_ERASEBKGND;
  protected
    procedure WndProc(var Message: TMessage); override;
    procedure Change; override;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
  public
    constructor Create (AOwner : TComponent); override;
    destructor Destroy; override;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    MyMemo : TMyMemo;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//  TMyMemõCX^X𐶐
//  DoubleBuffered̒lɂẮCeRg[Ƃ̊֌ŴœKύX
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  i : Integer;
begin
  MyMemo := TMyMemo.Create(Self);
  MyMemo.Parent    := Self;
  MyMemo.Left      := 0;
  MyMemo.Top       := Button1.Top + Button1.Height + 5;
  MyMemo.Width     := Self.ClientWidth;
  MyMemo.Height    := Self.ClientHeight - MyMemo.Top;
  MyMemo.Anchors   := [akLeft, akRight, akTop, akBottom];
  MyMemo.Font.Size := 20;

  MyMemo.ScrollBars     := ssVertical;
  MyMemo.DoubleBuffered := True;

  for i := 0 to 9 do begin
    MyMemo.Lines.Add('TMyMemo');
  end;

  ActiveControl := MyMemo;
end;

{ TMyMemo }

//-----------------------------------------------------------------------------
//  TMyMemõRXgN^
//  wi摜p̃rbg}bv𐶐āCfBXN摜ǂݍ
//  ̃rbg}bvwĩuVɂ
//-----------------------------------------------------------------------------
constructor TMyMemo.Create(AOwner : TComponent);
begin
  inherited;

  FBitmap := TBitmap.Create;
  FBitmap.LoadFromFile('e316.bmp');
  FBrush := 0;
  FBrush := CreatePatternBrush(FBitmap.Handle);
end;

//-----------------------------------------------------------------------------
//  TMyMemõfXgN^
//-----------------------------------------------------------------------------
destructor TMyMemo.Destroy;
begin
  DeleteObject(FBrush);
  FreeAndNil(FBitmap);

  inherited;
end;

//-----------------------------------------------------------------------------
//  TMyMemoChange\bh
//  eLXgύXƎŔ郁\bh
//-----------------------------------------------------------------------------
procedure TMyMemo.Change;
begin
  inherited;
  if FBrush <> 0 then begin
    Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  TMyMemoWM_SIZEbZ[W
//  TMyMemoƓTCỸrbg}bv쐬Cɉ摜StretchDra
//  WndProcŏĂCł͕ʂɂ
//-----------------------------------------------------------------------------
procedure TMyMemo.WMSize(var Message: TWMSize);
var
  LBitmap : TBitmap;
begin
  inherited;

  if FBrush <> 0 then begin
    LBitmap := TBitmap.Create;
    try
      FBrush := 0;
      LBitmap.SetSize(ClientWidth, ClientHeight);
      LBitmap.Canvas.StretchDraw(ClientRect, FBitmap);
      FBrush := CreatePatternBrush(LBitmap.Handle);
    finally
      FreeAndNil(LBitmap);
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  WndProc
//  Rg[͔wi`ƃtHg╶̕ύXƐeEBhEɑ΂
//    WM_CTLCOLOREDIT
//    WM_CTLCOLORSTATIC
//  ƓɎgCN_CTLCOLOREDIT,CN_CTLCOLORSTATICbZ[W𔭍s
//  ̃bZ[W
//-----------------------------------------------------------------------------
procedure TMyMemo.WndProc(var Message: TMessage);
begin
  inherited;

  case Message.Msg of
  CN_CTLCOLOREDIT, CN_CTLCOLORSTATIC:
    begin
      if (Message.LParam = Integer(Handle)) and (FBrush <> 0) then begin
        SetBkMode(Message.WParam, TRANSPARENT);
        Message.Result := FBrush;
      end;
    end;
  WM_MOUSEWHEEL, WM_HSCROLL, WM_VSCROLL:
    begin
      if FBrush <> 0 then begin
        InvalidateRect(Handle, nil, False);
      end;
    end;
  WM_LBUTTONUP, WM_RBUTTONUP:
    begin
      if (FBrush <> 0) then begin
        InvalidateRect(Handle, nil, False);
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  WM_ERASEBKGNDbZ[W
//  NCAg̈Ŝ`悷
//  ҏWJnƕҏẄ̕`͏
//-----------------------------------------------------------------------------
procedure TMyMemo.WMEraseBkgnd(var Message: TWMEraseBkgnd);
var
  LCanvas : TControlCanvas;
begin
  if FBrush = 0 then begin
    inherited;
  end else begin
    LCanvas := TControlCanvas.Create;
    LCanvas.Lock;
    try
      LCanvas.Brush.Style := bsClear;
      //TCanvasւ̕`\ɂ
      LCanvas.Handle := Message.DC;
      LCanvas.StretchDraw(ClientRect, FBitmap);
    finally
      LCanvas.Unlock;
      LCanvas.Free;
    end;
    Message.Result := 1;
  end;
end;

end.
