//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GfBbgRg[(TEdit, TMemo)̔wi摜ɂ
//  TEdit̏ꍇ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2014N1222 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, plEdit;

type
  TMyEdit = class (TplEdit)
  private
    FBitmap : TBitmap;
    FBrush  : HBRUSH;
    procedure WMEraseBkgnd(var Message: TWmEraseBkgnd); message WM_ERASEBKGND;
  protected
    procedure WndProc(var Message: TMessage); override;
    procedure Change; override;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
  public
    constructor Create (AOwner : TComponent); override;
    destructor Destroy; override;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    MyEdit : TMyEdit;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//  TMyEdit̃CX^X𐶐
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  MyEdit := TMyEdit.Create(Self);
  MyEdit.Parent    := Self;
  MyEdit.AutoSize  := False;
  MyEdit.Left      := 0;
  MyEdit.Top       := Button1.Top + Button1.Height + 5;
  MyEdit.Width     := Self.ClientWidth;
  MyEdit.Height    := Self.ClientHeight - MyEdit.Top;
  MyEdit.Anchors   := [akLeft, akRight, akTop, akBottom];
  MyEdit.Font.Size := 20;

  MyEdit.VertAlignment := tvaCenter;
  MyEdit.LeftIndent    := 5;

  ActiveControl := MyEdit;
end;

{ TMyEdit }

//-----------------------------------------------------------------------------
//  TMyEdit̃RXgN^
//  wi摜p̃rbg}bv𐶐āCfBXN摜ǂݍ
//  ̃rbg}bvwĩuVɂ
//-----------------------------------------------------------------------------
constructor TMyEdit.Create(AOwner : TComponent);
begin
  inherited;

  FBitmap := TBitmap.Create;
  FBitmap.LoadFromFile('e316.bmp');
  FBrush := 0;
  FBrush := CreatePatternBrush(FBitmap.Handle);
end;

//-----------------------------------------------------------------------------
//  TMyEdit̃fXgN^
//-----------------------------------------------------------------------------
destructor TMyEdit.Destroy;
begin
  DeleteObject(FBrush);
  FreeAndNil(FBitmap);

  inherited;
end;

//-----------------------------------------------------------------------------
//  TMyEditChange\bh
//  eLXgύXƎŔ郁\bh
//-----------------------------------------------------------------------------
procedure TMyEdit.Change;
begin
  inherited;
  if FBrush <> 0 then begin
    Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  TMyEditWM_SIZEbZ[W
//  TMyEditƓTCỸrbg}bv쐬Cɉ摜StretchDra
//  WndProcŏĂCł͕ʂɂ
//-----------------------------------------------------------------------------
procedure TMyEdit.WMSize(var Message: TWMSize);
var
  LBitmap : TBitmap;
begin
  inherited;

  if FBrush <> 0 then begin
    LBitmap := TBitmap.Create;
    try
      FBrush := 0;
      LBitmap.SetSize(ClientWidth, ClientHeight);
      LBitmap.Canvas.StretchDraw(ClientRect, FBitmap);
      FBrush := CreatePatternBrush(LBitmap.Handle);
    finally
      FreeAndNil(LBitmap);
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  WndProc
//  Rg[͔wi`ƃtHg╶̕ύXƐeEBhEɑ΂
//    WM_CTLCOLOREDIT
//    WM_CTLCOLORSTATIC
//  ƓɎgCN_CTLCOLOREDIT,CN_CTLCOLORSTATICbZ[W𔭍s
//  ̃bZ[W
//-----------------------------------------------------------------------------
procedure TMyEdit.WndProc(var Message: TMessage);
begin
  inherited;

  case Message.Msg of
  CN_CTLCOLOREDIT, CN_CTLCOLORSTATIC:
    begin
      if (Message.LParam = Integer(Handle)) and (FBrush <> 0) then begin
        SetBkMode(Message.WParam, TRANSPARENT);
        Message.Result := FBrush;
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  WM_ERASEBKGNDbZ[W
//  NCAg̈Ŝ`悷
//  ҏWJnƕҏẄ̕`͏
//  WTEdit̏ꍇCWM_ERASEBKGNDbZ[W͕̏sv
//-----------------------------------------------------------------------------
procedure TMyEdit.WMEraseBkgnd(var Message: TWMEraseBkgnd);
var
  LCanvas : TControlCanvas;
begin
  if FBrush = 0 then begin
    inherited;
  end else begin
    LCanvas := TControlCanvas.Create;
    LCanvas.Lock;
    try
      LCanvas.Brush.Style := bsClear;
      //TCanvasւ̕`\ɂ
      LCanvas.Handle := Message.DC;
      LCanvas.StretchDraw(ClientRect, FBitmap);
    finally
      LCanvas.Unlock;
      LCanvas.Free;
    end;
    Message.Result := 1;
  end;
end;

end.
